<?php
ini_set('display_errors', 1);

require_once '../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'academic_session/functions/validate_faculty.php';
require_once $base_path_to_learning . 'academic_session/functions/functions.php';
require_once $base_path_to_learning.'functions/common_functions.php';

//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';

$postdata = json_decode(file_get_contents("php://input"), true);
//print_r($postdata);
checkIfNoPhpContentsReceive();

if ( !isset($postdata['institution_id']) or !checkIfIssetAndNotEmpty($postdata['institution_id']) or
!isset($postdata['announcement_id']) or !checkIfIssetAndNotEmpty($postdata['announcement_id']) or
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or !isset($postdata['jwt_token']) or  !isset($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}
validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$branch_id = $jwt_validate->data->branch_id;
$institution_id = $jwt_validate->data->institution_id;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id,["teacher"], null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

require_once $base_path_to_learning . 'user_management/user_versioning.php';

$version = isset($_POST['version']) ? $_POST['version'] : (isset($postdata['version']) ? $postdata['version'] : null);
$updated_time = isset($_POST['updated_time']) ? $_POST['updated_time'] : (isset($postdata['updated_time']) ? $postdata['updated_time'] : null);

$response = user_data_refresh($conn_rjllearning, $conn_rjllearning_specific,$version, $updated_time, $userid, $institution_id);

// either the user has to fill gst or pan or ledgerhead 
function deleteAnnouncementDetails($conn_rjllearning_specific,$institution_id,$branch_id, $announcement_id)
{
   
    $sql = "DELETE FROM  announcement WHERE id =? AND  institution_id = ? AND branch_id = ?";
    $stmt = $conn_rjllearning_specific->prepare($sql);
    $stmt->execute(array($announcement_id,$institution_id,$branch_id));
    $count = $stmt->rowCount();
    if($count == 1) {
        return "Delete announcement Successfully";
    } else {
        errorreturn("unable to delete announcement");
    }

}

if($postdata['function_type']  == "delete_announcement") {  
    
    $announcement_id = trim($postdata['announcement_id']);
    $institution_id = trim($postdata['institution_id']);    
    $check_academic_confirmation = CheckAcademicSession($conn_rjllearning_specific,$institution_id);
    if($check_academic_confirmation != true){
         errorreturn("Access denied. Academic session not active.");
    }
    
    $success['data'] = deleteAnnouncementDetails($conn_rjllearning_specific,$institution_id,$branch_id, $announcement_id);
    successreturn($success);
    
}